{% macro render_field_with_errors(field, description) %}
    <div class="form-group">
        {{field.label}}
        {% if description %}
            {{ field(class_="form-control", aria_describedby=field.name + "Help", **kwargs)|safe }}
            <small id="{{field.name}}Help" class="form-text text-muted">{{description}}</small>
        {% else %}
            {{ field(class_="form-control", **kwargs)|safe }}
        {% endif %}
        {% if field.errors %}
        <ul>
            {% for error in field.errors %}
                <li class="has-error">{{ error }}</li>
            {% endfor %}    
        </ul>
        {% endif %}
    </div>
{% endmacro %}

{% macro render_remember_forgot(field, render_forgot=False) %}
    <div class="clearfix">
        {{ field.label }} {{ field(**kwargs)|safe }}
        {% if render_forgot %}
            <a href="{{ url_for('security.forgot_password') }}" class="pull-right">Forgot password?</a>
        {% endif %}
    </div>
{% endmacro %}

{% macro render_field(field) %}
    <div class="form-group">
        {{ field(**kwargs)|safe }}
    </div>
{% endmacro %}

{% macro collapse_card_start(title, show=True, data_count=None) %}
    <a id="{{ title|hyphenate }}" class="anchor"></a>
    <div class="card">
        <h5 class="card-header">
        <a data-toggle="collapse" href="#collapse-{{ title|hyphenate }}" aria-expanded="true" aria-controls="collapse-{{ title|hyphenate }}" id="header-{{ title|hyphenate }}" class="d-block">
            <span class="fa fa-chevron-down fa-pull-right"></span>
            {{ title }} {{ '<span class="badge badge-primary">'|safe ~ data_count ~ '</span>'|safe if data_count is not none }}
        </a>
        </h5>
        <div id="collapse-{{ title|hyphenate }}" class="collapse{{ ' show' if show }}" aria-labelledby="header-{{ title|hyphenate }}">
            <div class="card-body">
{% endmacro %}

{% macro collapse_card_end(title=None) %}
            </div>
        </div> {{ "<!-- end collapse-"|safe ~ title|hyphenate ~ "-->"|safe if title is not none }}
    </div>
{% endmacro %}

{% macro card_link_by_title(title, prefix=None) %}
    <a href="{{ prefix if prefix is not none }}#{{ title|hyphenate }}">
{% endmacro %}

{% macro render_pagination(offset, limit, total, endpoint) %}
  {% set num_of_pages =  (total / limit) | round(0, 'ceil') | int %}
  {# Note: cur_page is and index starting at 0, whereas the label
     on the link will be an page index starting at 1 #}
  {% set cur_page =  (offset / limit) | round(0, 'floor') | int %}

  <ul class="pagination justify-content-end">
    {#  previous button enabled if not on or before first page #}
    {% if cur_page < 1 %}
        <li class="page-item disabled">
    {%  else %}
        <li class="page-item">
    {% endif %}
          <a href="{{ url_for(endpoint, offset=(cur_page-1)*limit, limit=limit) }}" class="page-link">
              Previous
          </a>
        </li>

    {#  show first page if not already included in range #}
    {% if cur_page > 1 %}
        <li class="page-item">
            <a href="{{ url_for(endpoint, offset=0, limit=limit) }}" class="page-link">
               1
            </a>
        </li>
    {% endif %}

      {#  show dots if first page not connected to/in range #}
      {% if cur_page > 2 %}
          <li class="page-item disabled">
              <a href="{{ url_for(endpoint, offset=0, limit=limit) }}" class="page-link">
                  ...
              </a>
          </li>
      {% endif %}

    {# Show range around current page, one page before, two after #}
    {%  for page in range(cur_page - 1, cur_page + 3) %}
      {%  if page >= 0 and page < num_of_pages %}
        {%  if page == cur_page %}
          <li class="page-item active">
        {%  else %}
          <li class="page-item">
        {% endif %}
            <a href="{{ url_for(endpoint, offset=page*limit, limit=limit) }}" class="page-link">
              {{ page + 1 }}
            </a>
          </li>
      {%  endif %}
    {% endfor %}

      {#  show dots if last page not connected to/in range #}
      {% if cur_page <= num_of_pages - 5 %}
          <li class="page-item disabled">
              <a href="{{ url_for(endpoint, offset=0, limit=limit) }}" class="page-link">
                  ...
              </a>
          </li>
      {% endif %}

      {#  show last page if not already included in range #}
      {% if cur_page <= num_of_pages - 4 %}
          <li class="page-item">
              <a href="{{ url_for(endpoint, offset=(num_of_pages-1)*limit, limit=limit) }}" class="page-link">
                  {{ num_of_pages }}
              </a>
          </li>
      {% endif %}

    {#  next button enabled if not on or past last page #}
    {% if cur_page >= num_of_pages - 1 %}
        <li class="page-item disabled">
            {%  else %}
        <li class="page-item">
    {% endif %}
        <a href="{{ url_for(endpoint, offset=(cur_page+1)*limit, limit=limit) }}" class="page-link">
            Next
        </a>
    </li>
  </ul>

{% endmacro %}